#include <stdint.h>
#include "bcm2835_periph.h"
#include "mmio.h"
#include "led.h"
#include "printk.h"
#include "gic-400.h"
#include "hardware_detect.h"

/* Interrupt handler */

void __attribute__((interrupt("IRQ"))) interrupt_handler(void) {

	/* Debug */
	// printk("In IRQ handler\n");

	/* In a full system we'd check to see what type of interrupt */
	/* and properly handle the different kind */
	/* For now just assume it was a timer interrupt as that's all */
	/* That we've enabled */


	/* Clear the ARM Timer interrupt		*/

// YOUR CODE HERE


	/* Toggle the LED state */
	/* You can use the provided led_on() and led_off() functions */

// YOUR CODE HERE


	/* On Pi4 Clear the gic-400 pending bit */
	if (hardware_type==RPI_MODEL_4B) {
		mmio2_write(GICD_ICPENDR0,0xffffffffUL);
	}

}

