#include <stdint.h>
#include "bcm2835_periph.h"
#include "led.h"
#include "mmio.h"
//#include "hardware.h"
#include "gpio.h"
#include "printk.h"

static uint32_t led_gpio=18;

/* Enable GPIO for the GPIO18 LED */
int led_init(void) {

	/* We use an external LED */
	/* As the ACT LED is hard to get to on Pi3 */

//	led_gpio=42;

	gpio_request(led_gpio,"act_led");
	gpio_direction_output(led_gpio);

	printk("Starting heartbeat LED on GPIO%d\n",led_gpio);

	return 0;

}

int led_on(void) {

//	printk("Turning LED on\r\n");

	gpio_set_value(led_gpio,1);

	return 0;
}

int led_off(void) {

//	printk("Turning LED off\r\n");

	gpio_set_value(led_gpio,0);

	return 0;
}
